function setup()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		// The preferences are retrieved:
		var mirrorWidth = widget.preferenceForKey("mirrorWidth");
	   var mirrorHeight = widget.preferenceForKey("mirrorHeight");
	   
	   
		
		if (mirrorWidth > 0)  // if the retrieved preferences are not empty,
		{											// they are restored.
        window.resizeTo(mirrorWidth, mirrorHeight);
		}
		else
		{											
		mirrorWidth = 300 ;
		mirrorHeight = 300 ;
		 window.resizeTo(mirrorWidth, mirrorHeight);
	   }
			
	 document.getElementById("mirrorPopup").style.left = ( mirrorWidth / 2 - 70) ;
     document.getElementById("mirrorPopup").style.top = ( mirrorHeight *0.2) ;
     document.getElementById("logo").style.left = ( mirrorWidth / 2 - 100) ;
     document.getElementById("logo").style.top = ( mirrorHeight / 2 -30) ;
     document.getElementById("doneButton").style.left =  ( mirrorWidth / 2 - 30) ;
     document.getElementById("doneButton").style.top = (mirrorHeight -60) ;	   
	}
}


function changeMirror(elem)
{       
        var mirrorSize = document.getElementById("mirrorPopup").value;
        
        switch( parseInt(elem.options[elem.selectedIndex].value) )                                      // find out which option was chosen
        {
                case 1: 
                    mirrorSize=200;
                                        if(window.widget)
                                        {
                                        widget.setPreferenceForKey("200","mirrorSize");  
                                        document.getElementById("mirrorPopup").style.left = "30";
                                        document.getElementById("mirrorPopup").style.top = "30";
                                        document.getElementById("logo").style.left = "1";
                                        document.getElementById("logo").style.top = "70";
                                        document.getElementById("doneButton").style.left = "70";
                                        document.getElementById("doneButton").style.top = "140";
                                        window.resizeTo(mirrorSize, mirrorSize);
                                        }
                break;
                case 2:
                    mirrorSize=300;
                                        if(window.widget)
                                        {
                                        widget.setPreferenceForKey("300","mirrorSize");                                                     
                                        document.getElementById("mirrorPopup").style.left = "80";
                                        document.getElementById("mirrorPopup").style.top = "60";
                                        document.getElementById("logo").style.left = "50";
                                        document.getElementById("logo").style.top = "120";
                                        document.getElementById("doneButton").style.left = "120";
                                        document.getElementById("doneButton").style.top = "220";
                                         window.resizeTo(mirrorSize, mirrorSize);
                                         }
                break;
                case 3: 
                    mirrorSize=480;
                                        if(window.widget)
                                        {
                                        widget.setPreferenceForKey("476","mirrorSize");                                                     
                                         document.getElementById("mirrorPopup").style.left = "170";
                                        document.getElementById("mirrorPopup").style.top = "140";
                                        document.getElementById("logo").style.left = "140";
                                        document.getElementById("logo").style.top = "220";
                                        document.getElementById("doneButton").style.left = "210";
                                        document.getElementById("doneButton").style.top = "320";
                                         window.resizeTo(mirrorSize, mirrorSize - 8);
                                         }
                break;
                }
              // window.resizeTo(mirrorSize, mirrorSize);
             //  window.resizeTo(400, 400);

}

//*************

var lastPos; 
function mouseDownResize(event) 
{ 
    var x = event.x + window.screenX; 
    var y = event.y + window.screenY; 
    document.addEventListener("mousemove", mouseMoveResize, true); 
    document.addEventListener("mouseup", mouseUpResize, true); 
    lastPos = {x:x, y:y}; 
    event.stopPropagation(); 
    event.preventDefault(); 
} 
function mouseMoveResize(event) 
{ 
    var screenX = event.x + window.screenX; 
    var screenY = event.y + window.screenY; 
    var deltaX = 0;		// will hold the change since the last mouseMove event
	var deltaY = 0;

	if ( (window.outerWidth + (screenX - lastPos.x)) >= 200 ) { 
	    if ( (window.outerWidth + (screenX - lastPos.x)) < 480 ) { 		
            deltaX = screenX - lastPos.x;								
        	lastPos.x = screenX;										
        }
    }

	if ( (window.outerHeight + (screenY - lastPos.y)) >= 200 ) {	
    	if ( (window.outerHeight + (screenY - lastPos.y)) < 480 ) { 	
           deltaY = screenY - lastPos.y;
    		lastPos.y = screenY;
        }
	}
	
	window.resizeBy(deltaX, deltaY);
    
} 
function mouseUpResize(event) 
{ 
    var screenX = window.outerWidth;
    var screenY = window.outerHeight; 
    
    document.removeEventListener("mousemove", mouseMoveResize, true); 
    document.removeEventListener("mouseup", mouseUpResize, true); 
    event.stopPropagation(); 
    event.preventDefault(); 
        
     document.getElementById("mirrorPopup").style.left = ( screenX / 2 - 70) ;
     document.getElementById("mirrorPopup").style.top = ( screenY *0.2) ;
     document.getElementById("logo").style.left = ( screenX / 2 - 100) ;
     document.getElementById("logo").style.top = ( screenY / 2 -30) ;
     document.getElementById("doneButton").style.left =  ( screenX / 2 - 30) ;
     document.getElementById("doneButton").style.top = (screenY -60) ;

    widget.setPreferenceForKey(window.outerWidth,"mirrorWidth"); 
    widget.setPreferenceForKey(window.outerHeight,"mirrorHeight");                                      
} 


function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

    window.resizeBy(0, -8);
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front

    window.resizeBy(0, 8);
    widget.setPreferenceForKey(window.outerWidth,"mirrorWidth"); 
    widget.setPreferenceForKey(window.outerHeight,"mirrorHeight"); 
}

    

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};



function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}